function [X_ordered, X_dist, X_ndx ] = ff_traversal(X, to_mex)

if nargin<2
    to_mex = 1;
end


if to_mex
    [X_ndx,X_dist] = ff_traversal_mex(X');
    X_ordered = X(X_ndx,:);
    return;
end




%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  WORKING MATLAB CODE BELOW %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
pts = size(X,1);

idxs = ones(pts,1)==1;
X_ndx = nan(pts,1);
X_dist = nan(pts,1);
X_ordered = nan(size(X));

if pts==0; return; end;


x_inf = inf(1,size(X,2));

c=0;
while sum(idxs)>0
    c=c+1;
    to_X = X(idxs,:);
    fr_X = [X(~idxs,:); x_inf];
%    dst = pdist2(to_X, fr_X); % X, X(X_ndx,:)x_pick );
%    [mx_dist, ndx_pick] = max(min(dst,[],2));
    
    [~,dst] = knnsearch(fr_X,to_X);
    [mx_dist, ndx_pick] = max(dst);
    
    
    x_pick = to_X(ndx_pick,:);
    X_ordered(c,:) = x_pick;
    
    nd = find(idxs);
    X_ndx(c) = nd(ndx_pick);
    if c>1
        X_dist(c-1) = mx_dist;
    end
    idxs( X_ndx(c))=false;
end
X_dist(end) = 0;


