function predict_ytest = kernel_regressor_predict(xtest, learned_params, bandwidth, kernel_fcn)
    Y = learned_params.Y;
    X_tree = learned_params.X_tree;
    X = learned_params.X;
    
    avgY = mean(Y,1);
    [all_idx] = rangesearch(X_tree,xtest,bandwidth);
    
    nq = ones(size(X,1),1);
    predict_ytest = nan(size(xtest,1),size(Y,2));
    for i=1:size(xtest,1)
        idx = all_idx{i};
        if(sum(idx)==0); 
            Ypred = avgY; 
        else
            xtest_pt = xtest(i,:);
            Xsel = X(idx,:);
            Nsel = nq(idx,:);
            dst = pdist2(Xsel,xtest_pt);
            n = size(X,1);
            
            Ysel = Y(idx,:);
            wt = Nsel .* kernel_fcn(dst/bandwidth);
            Ypred = (sum(repmat(wt,1,size(Ysel,2)).* Ysel,1)  + eps*n*avgY) ./ (sum(wt)+eps*n);
        end
        predict_ytest(i,:) = Ypred;
        
    end
end

