function Y_hat = rnets_predict(xtest, learned_params, kernel_fcn)

    ntestpts = size(xtest,1);
    rnet = learned_params.rnet;
    bandwidth = learned_params.bandwidth;
    rdata = rnet.rData;
    closest_q_pred_ndx = rangesearch(rdata.net, xtest, bandwidth);
    
    meanY = rnet.meanY;
    n=rnet.n;
    qdata = rnet.Qall;

    Y_hat = nan(ntestpts,size(meanY,2));
    for i=1:ntestpts
        
        x_pred = xtest(i,:);
        allqndx = closest_q_pred_ndx{i};
        if isempty(allqndx); Y_hat(i,:)=meanY; continue; end;
        
        Nq = rdata.all_Nq(allqndx);
        Yq = rdata.all_Yq(allqndx,:);
        Qq = qdata(allqndx,:);
        
        nanidx = isnan(Yq);
        if sum(~nanidx)==0; Y_hat(i,:)=meanY; continue; end;
        
        Nq = Nq(~nanidx,:);
        Yq = Yq(~nanidx,:);
        Qq = Qq(~nanidx,:);
        
        dst_xq = pdist2(Qq,x_pred);
        
        wts = Nq .* kernel_fcn(dst_xq/bandwidth);
        Y_hat(i,:) = (sum(repmat(wts, 1, size(Yq, 2)) .* Yq) + eps*n*meanY) /  (sum(wts)+eps*n);
    end
end




