function params = rnets_train(X,Y, alpha, bandwidth, ff_traversal_data)

% alpha in [0,1],  closer to 0 ==> good accuracy
%                  closer to 1 ==> good speed
%
% alpha = 1/4 works well
%

    mean_Y = mean(Y,1);
    n = size(X,1);
    
    Qall = ff_traversal_data.Qall;
    Qdst = ff_traversal_data.Qdst;
    Qndx = ff_traversal_data.Qndx;
    
    rnet = [];
    params.bandwidth = bandwidth;
    rnet.n = n;
    rnet.alpha = alpha;
    rnet.meanY = mean_Y;
    rnet.Qall = Qall;
    rnet.Qdst = Qdst;
    rnet.Qndx = Qndx;
    
    r = alpha*bandwidth;
    cutoff = sum(Qdst>=r)+1;
    Q_r = Qall(1:cutoff,:);
    
    net = createns(Q_r,'nsmethod','kdtree');
    
    [all_n,all_meany] = computestats(Y,knnsearch(net,X),cutoff);
    
    rData = [];
    rData.Qall_cutoff = cutoff;
    rData.curr_r = r;
    rData.net = net;
    rData.all_Nq = all_n;
    rData.all_Yq = all_meany;
    rnet.rData = rData;
        
    params.rnet = rnet;
end
